<?php
/* Informátor
 *
 * Skript  slouží jako příslušenství k aplikaci Informator.exe.
 * Informace o použití lze nalézt v nápovědě k uvedené aplikaci.
 *
 * Verze 1.2, leden 2009
 *
 * Copyright © Petr Červinka 2008-2009 <petr@programator.unas.cz>
 */

$log     = "./data.log";    //Soubor s informacemi o posledním přístupu. 
$rezerva = 30;              //Časová rezerva v sekundách.
$minimal = 2;               //Minimální interval (v minutách) při výpadku.

function minuty($min){
   if ($min <= 4 && $min > 1){
      $s = $min." minuty";
   }elseif ($min == 1){
      $s = $min." minuta";
   }else{
      $s = $min." minut";
   }
   return $s;
}

$time = time();
$date = gmdate("D, d M Y H:i:s", $time);

if (isset($_GET["interval"])){
   $a = explode("/", $_SERVER["HTTP_USER_AGENT"], 2);
   if ($a[0] == "Informator" && $_SERVER["HTTP_ACCEPT"] == "text/plain" &&
      false!==strpos($_SERVER["HTTP_REFERER"], $_SERVER["QUERY_STRING"])){
      $fp = fopen($log, "w");
      fwrite($fp, date("Y-m-d H:i:s", $_SERVER["REQUEST_TIME"])."\n".
                  $_GET["interval"]."\n".
                  $_SERVER["REMOTE_ADDR"]."\n".
                  $_SERVER["REMOTE_PORT"]."\n".
                  $_SERVER["HTTP_USER_AGENT"]."\n");
      fclose($fp);
      header("Cache-Control: no-cache, must-revalidate");
      header("Expires: ".$date." GMT");
      header("Content-Type: text/plain; charset=utf-8");
      header("X-Response-For: ".$_SERVER["HTTP_USER_AGENT"]);
      echo "\n";
   }
   exit;
}
if (file_exists($log)){
   $f = file($log);
   for ($i = 0; $i < count($f); $i++){
      $f[$i] = rtrim($f[$i]);
   }
   $rt = strtotime($f[0]);
   $interval = $f[1] < $minimal ? $minimal : $f[1];
   if ($rt + $interval * 60 + $rezerva < $time){
      $interval = $minimal;
      $trida = "varovani";
   }else{
      $trida = "vporadku";
   }
   $klient = $f[4]!="" ? $f[4] : "<i>n/a</i>";
   $vypis = "<strong>Poslední požadavek:</strong> ".date("j. n. Y, G:i:s", $rt).
            "<br>\n<strong>Interval požadavku:</strong> ".minuty($f[1]).
            "<br>\n<strong>Poslední obnovení:</strong> ".date("j. n. Y, G:i:s", $time).
            "<br>\n<strong>Interval obnovení:</strong> ".minuty($interval).
            "<br>\n<strong>IP adresa:</strong> ".$f[2].
            "<br>\n<strong>Port:</strong> ".$f[3].
            "<br>\n<strong>Klient:</strong> ".$klient;
}else{
   $interval = 10;
   $trida = "varovani";
   $vypis = "<strong>Chyba:</strong> Log neexistuje";
}
$refresh = ($interval * 60).";url=".basename($_SERVER["PHP_SELF"]);

header("Cache-Control: no-cache, must-revalidate");
header("Expires: ".$date." GMT");
header("Content-Type: text/html; charset=utf-8");
header("Refresh: ".$refresh);
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
 "http://www.w3.org/TR/html4/loose.dtd">

<html>
<head>
<title>Informátor</title>
<meta http-equiv="Cache-Control" content="no-cache, must-revalidate">
<meta http-equiv="Expires" content="<?php echo $date; ?> GMT">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="Refresh" content="<?php echo $refresh; ?>">
<meta http-equiv="Content-Language" content="cs">
<style type="text/css">
body {
   background-color: #FFF;
   color: #000;
   font-family: Verdana, Arial, sans-serif;
   font-size: small;
}
strong {
   color: #B29100;
}
div {
   width: 500px;
   padding: 10px;
   line-height: 23px;
}
.varovani {
   border: 2px solid #E03;
   background-color: #FEE;
}
.vporadku {
   border: 2px solid #40BB85;
   background-color: #DFE;
}
</style>
</head>

<body>
<?php echo "<div class=\"".$trida."\">".$vypis."</div>\n"; ?>
</body>
</html>
